<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.12"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>eduRayTracer: src/Triangle.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">eduRayTracer
   &#160;<span id="projectnumber">v_2017_2018_1</span>
   </div>
   <div id="projectbrief">An Educational Ray Tracing Software Package (by Pedro Santana, ISCTE-IUL)</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.12 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('_triangle_8hpp_source.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">Triangle.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_triangle_8hpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * eduRayTracer - An Educational Ray Tracing Software Package</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> * Contributor(s): Pedro Santana - ISCTE-IUL (2014-2016)</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;</div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#ifndef _H_Triangle_</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">#define _H_Triangle_</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;</div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_surface_8hpp.html">Surface.hpp</a>&quot;</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_vertex_8hpp.html">Vertex.hpp</a>&quot;</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_ray_8hpp.html">Ray.hpp</a>&quot;</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_material_8hpp.html">Material.hpp</a>&quot;</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;</div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160; </div><div class="line"><a name="l00016"></a><span class="lineno"><a class="line" href="class_triangle.html">   16</a></span>&#160;<span class="keyword">class </span><a class="code" href="class_triangle.html">Triangle</a> : <span class="keyword">public</span> <a class="code" href="class_surface.html">Surface</a>{</div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;</div><div class="line"><a name="l00020"></a><span class="lineno"><a class="line" href="class_triangle.html#a12003cd84b412dd2a2253b201b7189a0">   20</a></span>&#160;    <a class="code" href="class_vertex.html">Vertex</a> *<a class="code" href="class_triangle.html#a12003cd84b412dd2a2253b201b7189a0">va</a>;</div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;</div><div class="line"><a name="l00023"></a><span class="lineno"><a class="line" href="class_triangle.html#a276cdaae7a99660028d5d3530431bc8e">   23</a></span>&#160;    <a class="code" href="class_vertex.html">Vertex</a> *<a class="code" href="class_triangle.html#a276cdaae7a99660028d5d3530431bc8e">vb</a>;</div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;</div><div class="line"><a name="l00026"></a><span class="lineno"><a class="line" href="class_triangle.html#ad6c3aeb4dfa5d4a0ee3b34805d6de283">   26</a></span>&#160;    <a class="code" href="class_vertex.html">Vertex</a> *<a class="code" href="class_triangle.html#ad6c3aeb4dfa5d4a0ee3b34805d6de283">vc</a>;</div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;    </div><div class="line"><a name="l00029"></a><span class="lineno"><a class="line" href="class_triangle.html#a2f980c8c1beeaab12eab97aa5b7b892c">   29</a></span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="class_triangle.html#a2f980c8c1beeaab12eab97aa5b7b892c">cw</a>;</div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;    </div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;</div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;    <a class="code" href="class_triangle.html#ad1123953a9627f69f12bb966e002390d">Triangle</a> (<a class="code" href="class_vertex.html">Vertex</a> *_va, <a class="code" href="class_vertex.html">Vertex</a> *_vb, <a class="code" href="class_vertex.html">Vertex</a> *_vc, <span class="keywordtype">bool</span> _cw, <a class="code" href="class_material.html">Material</a> *_m);</div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;</div><div class="line"><a name="l00050"></a><span class="lineno"><a class="line" href="class_triangle.html#a77b03e725df90ade03220f59cc63e519">   50</a></span>&#160;    <a class="code" href="class_triangle.html#a77b03e725df90ade03220f59cc63e519">Triangle</a> (std::string _id, <a class="code" href="class_vertex.html">Vertex</a> *_va, <a class="code" href="class_vertex.html">Vertex</a> *_vb, <a class="code" href="class_vertex.html">Vertex</a> *_vc, <span class="keywordtype">bool</span> _cw, <a class="code" href="class_material.html">Material</a> *_m) : <a class="code" href="class_triangle.html">Triangle</a> (_va, _vb, _vc, _cw, _m){</div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;        <span class="keywordtype">id</span> = _id;</div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;    }</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;</div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;</div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;    <a class="code" href="class_triangle.html#ad1123953a9627f69f12bb966e002390d">Triangle</a> (<a class="code" href="class_vertex.html">Vertex</a> *_va, <a class="code" href="class_vertex.html">Vertex</a> *_vb, <a class="code" href="class_vertex.html">Vertex</a> *_vc, <span class="keywordtype">bool</span> _cw, <a class="code" href="class_material.html">Material</a> *_m, <span class="keywordtype">bool</span> _smooth_shading);</div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160; </div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;</div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;</div><div class="line"><a name="l00076"></a><span class="lineno"><a class="line" href="class_triangle.html#a832e2951677446251badffbfc3936715">   76</a></span>&#160;    <a class="code" href="class_triangle.html#a832e2951677446251badffbfc3936715">Triangle</a> (std::string _id, <a class="code" href="class_vertex.html">Vertex</a> *_va, <a class="code" href="class_vertex.html">Vertex</a> *_vb, <a class="code" href="class_vertex.html">Vertex</a> *_vc, <span class="keywordtype">bool</span> _cw, <a class="code" href="class_material.html">Material</a> *_m, <span class="keywordtype">bool</span> _smooth_shading) :</div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;                                                                            <a class="code" href="class_triangle.html">Triangle</a> (_va, _vb, _vc, _cw, _m, _smooth_shading){</div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;        <span class="keywordtype">id</span> = _id;</div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;    }</div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;</div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="class_triangle.html#a021fb26d1e764935add59709d8b1112f">bounding_box</a>();</div><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;</div><div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;</div><div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;    <span class="keyword">virtual</span> <a class="code" href="class_box.html">Box</a> <a class="code" href="class_triangle.html#a8d4b4ef6090fb1bc4ceec217ff8991ec">getBBox</a>();</div><div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;    </div><div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;</div><div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;    <span class="keyword">virtual</span> <a class="code" href="class_vec.html">Vec</a> <a class="code" href="class_triangle.html#ae7c4f3cf55493686d174ff4196477739">getCentroid</a>();</div><div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;</div><div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;</div><div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="class_triangle.html#a07aa3c7813a34fd89441344130262b44">hit</a>(<span class="keyword">const</span> <a class="code" href="class_ray.html">Ray</a> &amp;r, <a class="code" href="structhit__rec.html">hit_rec</a> &amp;h_r, <span class="keywordtype">double</span> t_min, <span class="keywordtype">double</span> t_max);</div><div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;    </div><div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;</div><div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="class_triangle.html#a78d01c00d6c3ddd7cd15b7d8270622fa">addSurfaces</a>(std::vector&lt;Surface*&gt; &amp;objects);</div><div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;    </div><div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;};</div><div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;</div><div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;<span class="preprocessor">#endif</span></div><div class="ttc" id="class_vertex_html"><div class="ttname"><a href="class_vertex.html">Vertex</a></div><div class="ttdoc">A class to create and manipulate 3D vertexes. </div><div class="ttdef"><b>Definition:</b> Vertex.hpp:18</div></div>
<div class="ttc" id="class_surface_html"><div class="ttname"><a href="class_surface.html">Surface</a></div><div class="ttdoc">A base class for every geometry class (e.g., Sphere, Triangle, Mesh). </div><div class="ttdef"><b>Definition:</b> Surface.hpp:40</div></div>
<div class="ttc" id="_ray_8hpp_html"><div class="ttname"><a href="_ray_8hpp.html">Ray.hpp</a></div></div>
<div class="ttc" id="class_triangle_html_a832e2951677446251badffbfc3936715"><div class="ttname"><a href="class_triangle.html#a832e2951677446251badffbfc3936715">Triangle::Triangle</a></div><div class="ttdeci">Triangle(std::string _id, Vertex *_va, Vertex *_vb, Vertex *_vc, bool _cw, Material *_m, bool _smooth_shading)</div><div class="ttdoc">A Triangle&amp;#39;s constructor for rendering with/without with Phong interpolation. </div><div class="ttdef"><b>Definition:</b> Triangle.hpp:76</div></div>
<div class="ttc" id="class_triangle_html_a8d4b4ef6090fb1bc4ceec217ff8991ec"><div class="ttname"><a href="class_triangle.html#a8d4b4ef6090fb1bc4ceec217ff8991ec">Triangle::getBBox</a></div><div class="ttdeci">virtual Box getBBox()</div><div class="ttdoc">Returns the bounding box of this triangle. </div><div class="ttdef"><b>Definition:</b> Triangle.cpp:98</div></div>
<div class="ttc" id="class_triangle_html"><div class="ttname"><a href="class_triangle.html">Triangle</a></div><div class="ttdoc">A class to create and manipulate triangles. </div><div class="ttdef"><b>Definition:</b> Triangle.hpp:16</div></div>
<div class="ttc" id="class_triangle_html_a77b03e725df90ade03220f59cc63e519"><div class="ttname"><a href="class_triangle.html#a77b03e725df90ade03220f59cc63e519">Triangle::Triangle</a></div><div class="ttdeci">Triangle(std::string _id, Vertex *_va, Vertex *_vb, Vertex *_vc, bool _cw, Material *_m)</div><div class="ttdoc">A Triangle&amp;#39;s constructor for rendering with Phong interpolation. </div><div class="ttdef"><b>Definition:</b> Triangle.hpp:50</div></div>
<div class="ttc" id="class_triangle_html_ae7c4f3cf55493686d174ff4196477739"><div class="ttname"><a href="class_triangle.html#ae7c4f3cf55493686d174ff4196477739">Triangle::getCentroid</a></div><div class="ttdeci">virtual Vec getCentroid()</div><div class="ttdoc">Returns the centroid of this triangle. </div><div class="ttdef"><b>Definition:</b> Triangle.cpp:102</div></div>
<div class="ttc" id="_vertex_8hpp_html"><div class="ttname"><a href="_vertex_8hpp.html">Vertex.hpp</a></div></div>
<div class="ttc" id="class_triangle_html_ad6c3aeb4dfa5d4a0ee3b34805d6de283"><div class="ttname"><a href="class_triangle.html#ad6c3aeb4dfa5d4a0ee3b34805d6de283">Triangle::vc</a></div><div class="ttdeci">Vertex * vc</div><div class="ttdoc">Pointer to the third vertex of the Triangle. </div><div class="ttdef"><b>Definition:</b> Triangle.hpp:26</div></div>
<div class="ttc" id="class_material_html"><div class="ttname"><a href="class_material.html">Material</a></div><div class="ttdoc">A class to create and manipulate surface materials. </div><div class="ttdef"><b>Definition:</b> Material.hpp:19</div></div>
<div class="ttc" id="class_triangle_html_a12003cd84b412dd2a2253b201b7189a0"><div class="ttname"><a href="class_triangle.html#a12003cd84b412dd2a2253b201b7189a0">Triangle::va</a></div><div class="ttdeci">Vertex * va</div><div class="ttdoc">Pointer to the first vertex of the Triangle. </div><div class="ttdef"><b>Definition:</b> Triangle.hpp:20</div></div>
<div class="ttc" id="class_triangle_html_a78d01c00d6c3ddd7cd15b7d8270622fa"><div class="ttname"><a href="class_triangle.html#a78d01c00d6c3ddd7cd15b7d8270622fa">Triangle::addSurfaces</a></div><div class="ttdeci">virtual void addSurfaces(std::vector&lt; Surface *&gt; &amp;objects)</div><div class="ttdoc">Adds this triangle (its pointer, actually) to a given vector of surfaces. </div><div class="ttdef"><b>Definition:</b> Triangle.cpp:107</div></div>
<div class="ttc" id="class_triangle_html_a021fb26d1e764935add59709d8b1112f"><div class="ttname"><a href="class_triangle.html#a021fb26d1e764935add59709d8b1112f">Triangle::bounding_box</a></div><div class="ttdeci">void bounding_box()</div><div class="ttdoc">Computes the bounding box of this triangle. </div><div class="ttdef"><b>Definition:</b> Triangle.cpp:111</div></div>
<div class="ttc" id="class_vec_html"><div class="ttname"><a href="class_vec.html">Vec</a></div><div class="ttdoc">A class to create and manipulate 3D vectors. These can be used to store positions, normals, and RGB triplets. </div><div class="ttdef"><b>Definition:</b> Vec.hpp:16</div></div>
<div class="ttc" id="class_triangle_html_ad1123953a9627f69f12bb966e002390d"><div class="ttname"><a href="class_triangle.html#ad1123953a9627f69f12bb966e002390d">Triangle::Triangle</a></div><div class="ttdeci">Triangle(Vertex *_va, Vertex *_vb, Vertex *_vc, bool _cw, Material *_m)</div><div class="ttdoc">A Triangle&amp;#39;s constructor for rendering with Phong interpolation. </div><div class="ttdef"><b>Definition:</b> Triangle.cpp:8</div></div>
<div class="ttc" id="_material_8hpp_html"><div class="ttname"><a href="_material_8hpp.html">Material.hpp</a></div></div>
<div class="ttc" id="class_box_html"><div class="ttname"><a href="class_box.html">Box</a></div><div class="ttdef"><b>Definition:</b> Box.hpp:12</div></div>
<div class="ttc" id="_surface_8hpp_html"><div class="ttname"><a href="_surface_8hpp.html">Surface.hpp</a></div></div>
<div class="ttc" id="class_triangle_html_a2f980c8c1beeaab12eab97aa5b7b892c"><div class="ttname"><a href="class_triangle.html#a2f980c8c1beeaab12eab97aa5b7b892c">Triangle::cw</a></div><div class="ttdeci">bool cw</div><div class="ttdoc">Flag stating if vertexes are provided in clock-wise order (for normal computation) ...</div><div class="ttdef"><b>Definition:</b> Triangle.hpp:29</div></div>
<div class="ttc" id="class_triangle_html_a07aa3c7813a34fd89441344130262b44"><div class="ttname"><a href="class_triangle.html#a07aa3c7813a34fd89441344130262b44">Triangle::hit</a></div><div class="ttdeci">bool hit(const Ray &amp;r, hit_rec &amp;h_r, double t_min, double t_max)</div><div class="ttdoc">Checks if a given Ray intersects this Triangle and, if so, a hit record is filled in...</div><div class="ttdef"><b>Definition:</b> Triangle.cpp:43</div></div>
<div class="ttc" id="class_ray_html"><div class="ttname"><a href="class_ray.html">Ray</a></div><div class="ttdoc">A class to create and manipulate 3D rays. </div><div class="ttdef"><b>Definition:</b> Ray.hpp:12</div></div>
<div class="ttc" id="class_triangle_html_a276cdaae7a99660028d5d3530431bc8e"><div class="ttname"><a href="class_triangle.html#a276cdaae7a99660028d5d3530431bc8e">Triangle::vb</a></div><div class="ttdeci">Vertex * vb</div><div class="ttdoc">Pointer to the second vertex of the Triangle. </div><div class="ttdef"><b>Definition:</b> Triangle.hpp:23</div></div>
<div class="ttc" id="structhit__rec_html"><div class="ttname"><a href="structhit__rec.html">hit_rec</a></div><div class="ttdoc">A structure used to hold information regarding ray-surface intersection events. </div><div class="ttdef"><b>Definition:</b> Surface.hpp:20</div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li><li class="navelem"><a class="el" href="_triangle_8hpp.html">Triangle.hpp</a></li>
    <li class="footer">Generated on Fri Sep 15 2017 15:54:23 for eduRayTracer by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.12 </li>
  </ul>
</div>
</body>
</html>
